DATA_SECTION
  init_int nSplineNodes
  init_int nrow
  init_matrix xy(1,nrow,1,2)
  vector x(1,nrow)
  vector y(1,nrow)
  !! x=column(xy,1);  y=column(xy,2);
  vector nodes(1,nSplineNodes)
  !! nodes.fill_seqadd(min(x),(max(x)-min(x))/(nSplineNodes-1));

PARAMETER_SECTION
  init_vector yAtNodes(1,nSplineNodes)
  init_number logSigma;
  sdreport_number sigmasq;  
  objective_function_value nll; 
  sdreport_vector pred(1,nrow);

PROCEDURE_SECTION
  vcubic_spline_function qs(nodes,yAtNodes);   // NOTICE
  pred=qs(x);
  sigmasq=exp(2*logSigma);
  nll=0.5*(nrow*log(2*M_PI*sigmasq)+sum(square(y-pred))/sigmasq);

TOP_OF_MAIN_SECTION
  gradient_structure::set_NUM_DEPENDENT_VARIABLES(500);
