

DATA_SECTION
 init_int N
 init_matrix tyz(1,N,1,3)
 vector t(1,N)
 vector y(1,N)
 vector z(1,N)
 
PARAMETER_SECTION

 init_number logSX
 init_number logSdy
 init_number logSdz
 init_number X0
 
 random_effects_vector x(1,N);

 objective_function_value jnll;

PRELIMINARY_CALCS_SECTION

// read matrix data into vectors

  t = (column(tyz,1));
  y = (column(tyz,2));
  z = (column(tyz,3));

PROCEDURE_SECTION

 jnll=0.0;
 step(X0,x(1),logSX);

 for(int i=2; i<=N; ++i){
 step(x(i-1),x(i),logSX);
 }

 for(int i=1; i<=N; ++i){ 
 	      if(y(i) > 0){
	 obs(x(i),y(i),logSdy);
 }
	      if(z(i) > 0){
 	 obs(x(i),z(i),logSdz);
  }
 }


// TOP_OF_MAIN_SECTION
// arrmblsize=2000000;


SEPARABLE_FUNCTION void step(const dvariable& lam1, const dvariable& lam2, const dvariable& logSdLam)
  dvariable var=exp(2.0*logSdLam);
  jnll+=0.5*(log(2.0*M_PI*var)+square(lam2-lam1)/var);

SEPARABLE_FUNCTION void obs(const dvariable& lam, double& data, const dvariable& logSdy)
  dvariable var=exp(2.0*logSdy);
  jnll+=0.5*(log(2.0*M_PI*var)+square(lam-data)/var);

REPORT_SECTION

  report << "$X" << endl;
  report << x << endl;
  report << "$Y" << endl;
  report << y << endl;
  report << "$Z" << endl;
  report << z << endl;
